// Inv.c v1.1
// Matrix Inverse Algorith "ANA"
//
// Created 14/07/00; 10:52:46 a.m.
// by Rafael H. Padilla V.
// dysup@hotmail.com
//
// Modified in November 2002
// By Samuel Stearley
// sstear70@calvin.edu

#define OPTIMIZE_ROM_CALLS
#define NO_AMS_CHECK
#define NO_CALC_DETECT
#define NO_EXIT_SUPPORT
#define USE_TI89
#define USE_TI92PLUS

#include <tigcclib.h>
#include "matriz.h"


const char msg[] = "Ready:      ";

void _main(void)
{
   MatType A, B, TEMP;
   int i,j,k;
   int NumRow, porciento=0, incremento;
   ti_float r, p;
   ESI argptr = top_estack;

   if (!is_square_matrix(argptr)) return; //only square matrix.

   argptr -=2;
   NumRow = remaining_element_count(argptr); //num. of rows and cols.
   incremento = 100/NumRow;
   ST_showHelp("wait...");
 
   // create A and B matrix
   if (!(A = dim(NumRow, NumRow))) return;
   if (!(B = dim(NumRow, NumRow))) {
     free(A);
     ST_eraseHelp();
     return;
   }
	 int memFreed = 1;

	TRY
	  OSEnableBreak();
	  //take matrix A from the estack.  If there is a symbolic in the estack
    //that can not be approximated an error will be thrown.
    for (i=0; i<NumRow; i++) {
 	     for (j=0; j<NumRow; j++) {
				  NG_approxESI(argptr);
				  if (*top_estack != FLOAT_TAG) ER_throw(ER_INVALID_LIST_OR_MATRIX);
   	      A[i][j] = estack_number_to_Float(top_estack);
   	      argptr = next_expression_index(argptr);
				  top_estack = argptr;
   	   }
       argptr -= 2;
    }

 	  // Inverse for "el metodo ANA."
	  r = ONE;
		for (k=0; k<NumRow; k++) {
	     sprintf(msg+7,"%3d%%",porciento);
	     ST_showHelp(msg);
	     p = A[k][k];
	     for (j=0; j<NumRow; j++) {
	       B[k][j] = fneg(A[k][j]);
	       B[j][k] = A[j][k];
	     }
	     B[k][k] = r;

	     for (i=0; i<NumRow; i++){
				 if (i == k) continue;
		     for (j=0; j<NumRow; j++){
					 if (OSCheckBreak()) ER_throw(ER_BREAK);
					 if (j == k) continue;
					 B[i][j] = fdiv(fsub(fmul(p,A[i][j]),fmul(A[i][k],A[k][j])),r);
	       }
	     }
	     TEMP = A; A = B; B = TEMP;
	     r = p;
			 porciento+=incremento;
	   }
	   // return answer to estack.
	   push_END_TAG();
	   for (i=NumRow-1; i>=0; i--) {
	     push_END_TAG();
	     for (j=NumRow-1; j>=0; j--)
	       push_Float(fdiv(A[i][j],p));
	     push_LIST_TAG();
	   }
	   push_LIST_TAG();
		 free(A);		 //free ram before writing file
	   free(B);
		 memFreed = 0;
		 VarStore(SYMSTR("_asminfo"),STOF_ESI,0,top_estack);
	ONERR
		 if (memFreed){  // in case error is thrown by above VarStore()
			 free(A);
			 free(B);
		 }
		 ERD_process(errCode);
		 OSClearBreak();
	ENDTRY
		 ST_eraseHelp();
}